/* SUPER IMPORTANT!
        
    From:
    PIC18(L)F67K40 Family Silicon Errata and Data Sheet Clarification
    
    **********
    Section 3.1
    TBLRD requires NVMREG value to point to appropriate memory
    
    The affected silicon revisions of the PIC18FXXK40
    devices improperly require the NVMREG<1:0>
    bits in the NVMCON register to be set for TBLRD
    access of the various memory regions. The issue
    is most apparent in compiled C programs when the
    user defines a const type and the compiler uses
    TBLRD instructions to retrieve the data from
    program Flash memory (PFM). The issue is also
    apparent when the user defines an array in RAM
    for which the complier creates start-up code,
    executed before main(), that uses TBLRD
    instructions to initialize RAM from PFM.
    **********
    
    Work around code is below.
    
    Constants won't work in your C programs unless you include this file in your project!
    
*/
    
    
#include <xc.inc>
    GLOBAL powerup, start
    PSECT powerup, class=CODE, delta=1, reloc=2

powerup:
    BSF NVMCON1, 7
    GOTO start
    end
